gitweb: Show appropriate "Generating..." page when regenerating cache
[git/jnareb-git.git] / git-stash.sh
blob7561b374d2ec90fe774e98e39a121a1a3a3cdfa9
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet] [<message>]]
11 or: $dashless clear"
13 SUBDIRECTORY_OK=Yes
14 OPTIONS_SPEC=
15 . git-sh-setup
16 require_work_tree
17 cd_to_toplevel
19 TMP="$GIT_DIR/.git-stash.$$"
20 trap 'rm -f "$TMP-*"' 0
22 ref_stash=refs/stash
24 if git config --get-colorbool color.interactive; then
25 help_color="$(git config --get-color color.interactive.help 'red bold')"
26 reset_color="$(git config --get-color '' reset)"
27 else
28 help_color=
29 reset_color=
32 no_changes () {
33 git diff-index --quiet --cached HEAD --ignore-submodules -- &&
34 git diff-files --quiet --ignore-submodules
37 clear_stash () {
38 if test $# != 0
39 then
40 die "git stash clear with parameters is unimplemented"
42 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
43 then
44 git update-ref -d $ref_stash $current
48 create_stash () {
49 stash_msg="$1"
51 git update-index -q --refresh
52 if no_changes
53 then
54 exit 0
57 # state of the base commit
58 if b_commit=$(git rev-parse --verify HEAD)
59 then
60 head=$(git rev-list --oneline -n 1 HEAD --)
61 else
62 die "You do not have the initial commit yet"
65 if branch=$(git symbolic-ref -q HEAD)
66 then
67 branch=${branch#refs/heads/}
68 else
69 branch='(no branch)'
71 msg=$(printf '%s: %s' "$branch" "$head")
73 # state of the index
74 i_tree=$(git write-tree) &&
75 i_commit=$(printf 'index on %s\n' "$msg" |
76 git commit-tree $i_tree -p $b_commit) ||
77 die "Cannot save the current index state"
79 if test -z "$patch_mode"
80 then
82 # state of the working tree
83 w_tree=$( (
84 rm -f "$TMP-index" &&
85 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
86 GIT_INDEX_FILE="$TMP-index" &&
87 export GIT_INDEX_FILE &&
88 git read-tree -m $i_tree &&
89 git diff --name-only -z HEAD | git update-index -z --add --remove --stdin &&
90 git write-tree &&
91 rm -f "$TMP-index"
92 ) ) ||
93 die "Cannot save the current worktree state"
95 else
97 rm -f "$TMP-index" &&
98 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
100 # find out what the user wants
101 GIT_INDEX_FILE="$TMP-index" \
102 git add--interactive --patch=stash -- &&
104 # state of the working tree
105 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
106 die "Cannot save the current worktree state"
108 git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
109 test -s "$TMP-patch" ||
110 die "No changes selected"
112 rm -f "$TMP-index" ||
113 die "Cannot remove temporary index (can't happen)"
117 # create the stash
118 if test -z "$stash_msg"
119 then
120 stash_msg=$(printf 'WIP on %s' "$msg")
121 else
122 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
124 w_commit=$(printf '%s\n' "$stash_msg" |
125 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
126 die "Cannot record working tree state"
129 save_stash () {
130 keep_index=
131 patch_mode=
132 while test $# != 0
134 case "$1" in
135 -k|--keep-index)
136 keep_index=t
138 --no-keep-index)
139 keep_index=
141 -p|--patch)
142 patch_mode=t
143 keep_index=t
145 -q|--quiet)
146 GIT_QUIET=t
149 shift
150 break
153 echo "error: unknown option for 'stash save': $1"
154 echo " To provide a message, use git stash save -- '$1'"
155 usage
158 break
160 esac
161 shift
162 done
164 stash_msg="$*"
166 git update-index -q --refresh
167 if no_changes
168 then
169 say 'No local changes to save'
170 exit 0
172 test -f "$GIT_DIR/logs/$ref_stash" ||
173 clear_stash || die "Cannot initialize stash"
175 create_stash "$stash_msg"
177 # Make sure the reflog for stash is kept.
178 : >>"$GIT_DIR/logs/$ref_stash"
180 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
181 die "Cannot save the current status"
182 say Saved working directory and index state "$stash_msg"
184 if test -z "$patch_mode"
185 then
186 git reset --hard ${GIT_QUIET:+-q}
188 if test -n "$keep_index" && test -n $i_tree
189 then
190 git read-tree --reset -u $i_tree
192 else
193 git apply -R < "$TMP-patch" ||
194 die "Cannot remove worktree changes"
196 if test -z "$keep_index"
197 then
198 git reset
203 have_stash () {
204 git rev-parse --verify $ref_stash >/dev/null 2>&1
207 list_stash () {
208 have_stash || return 0
209 git log --format="%gd: %gs" -g "$@" $ref_stash --
212 show_stash () {
213 assert_stash_like "$@"
215 git diff ${FLAGS:---stat} $b_commit $w_commit
219 # Parses the remaining options looking for flags and
220 # at most one revision defaulting to ${ref_stash}@{0}
221 # if none found.
223 # Derives related tree and commit objects from the
224 # revision, if one is found.
226 # stash records the work tree, and is a merge between the
227 # base commit (first parent) and the index tree (second parent).
229 # REV is set to the symbolic version of the specified stash-like commit
230 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
231 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
232 # s is set to the SHA1 of the stash commit
233 # w_commit is set to the commit containing the working tree
234 # b_commit is set to the base commit
235 # i_commit is set to the commit containing the index tree
236 # w_tree is set to the working tree
237 # b_tree is set to the base tree
238 # i_tree is set to the index tree
240 # GIT_QUIET is set to t if -q is specified
241 # INDEX_OPTION is set to --index if --index is specified.
242 # FLAGS is set to the remaining flags
244 # dies if:
245 # * too many revisions specified
246 # * no revision is specified and there is no stash stack
247 # * a revision is specified which cannot be resolve to a SHA1
248 # * a non-existent stash reference is specified
251 parse_flags_and_rev()
253 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
254 PARSE_CACHE="$*"
256 IS_STASH_LIKE=
257 IS_STASH_REF=
258 INDEX_OPTION=
260 w_commit=
261 b_commit=
262 i_commit=
263 w_tree=
264 b_tree=
265 i_tree=
267 REV=$(git rev-parse --no-flags --symbolic "$@" 2>/dev/null)
269 FLAGS=
270 for opt
272 case "$opt" in
273 -q|--quiet)
274 GIT_QUIET=-t
276 --index)
277 INDEX_OPTION=--index
280 FLAGS="${FLAGS}${FLAGS:+ }$opt"
282 esac
283 done
285 set -- $REV
287 case $# in
289 have_stash || die "No stash found."
290 set -- ${ref_stash}@{0}
296 die "Too many revisions specified: $REV"
298 esac
300 REV=$(git rev-parse --quiet --symbolic --verify $1 2>/dev/null) || die "$1 is not valid reference"
302 i_commit=$(git rev-parse --quiet --verify $REV^2 2>/dev/null) &&
303 set -- $(git rev-parse $REV $REV^1 $REV: $REV^1: $REV^2: 2>/dev/null) &&
304 s=$1 &&
305 w_commit=$1 &&
306 b_commit=$2 &&
307 w_tree=$3 &&
308 b_tree=$4 &&
309 i_tree=$5 &&
310 IS_STASH_LIKE=t &&
311 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
312 IS_STASH_REF=t
314 if test "${REV}" != "${REV%{*\}}"
315 then
316 # maintainers: it would be better if git rev-parse indicated
317 # this condition with a non-zero status code but as of 1.7.2.1 it
318 # it did not. So, we use non-empty stderr output as a proxy for the
319 # condition of interest.
320 test -z "$(git rev-parse "$REV" 2>&1 >/dev/null)" || die "$REV does not exist in the stash log"
325 is_stash_like()
327 parse_flags_and_rev "$@"
328 test -n "$IS_STASH_LIKE"
331 assert_stash_like() {
332 is_stash_like "$@" || die "'$*' is not a stash-like commit"
335 is_stash_ref() {
336 is_stash_like "$@" && test -n "$IS_STASH_REF"
339 assert_stash_ref() {
340 is_stash_ref "$@" || die "'$*' is not a stash reference"
343 apply_stash () {
345 assert_stash_like "$@"
347 git update-index -q --refresh &&
348 git diff-files --quiet --ignore-submodules ||
349 die 'Cannot apply to a dirty working tree, please stage your changes'
351 # current index state
352 c_tree=$(git write-tree) ||
353 die 'Cannot apply a stash in the middle of a merge'
355 unstashed_index_tree=
356 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
357 test "$c_tree" != "$i_tree"
358 then
359 git diff-tree --binary $s^2^..$s^2 | git apply --cached
360 test $? -ne 0 &&
361 die 'Conflicts in index. Try without --index.'
362 unstashed_index_tree=$(git write-tree) ||
363 die 'Could not save index tree'
364 git reset
367 eval "
368 GITHEAD_$w_tree='Stashed changes' &&
369 GITHEAD_$c_tree='Updated upstream' &&
370 GITHEAD_$b_tree='Version stash was based on' &&
371 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
374 if test -n "$GIT_QUIET"
375 then
376 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
378 if git merge-recursive $b_tree -- $c_tree $w_tree
379 then
380 # No conflict
381 if test -n "$unstashed_index_tree"
382 then
383 git read-tree "$unstashed_index_tree"
384 else
385 a="$TMP-added" &&
386 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
387 git read-tree --reset $c_tree &&
388 git update-index --add --stdin <"$a" ||
389 die "Cannot unstage modified files"
390 rm -f "$a"
392 squelch=
393 if test -n "$GIT_QUIET"
394 then
395 squelch='>/dev/null 2>&1'
397 eval "git status $squelch" || :
398 else
399 # Merge conflict; keep the exit status from merge-recursive
400 status=$?
401 if test -n "$INDEX_OPTION"
402 then
403 echo >&2 'Index was not unstashed.'
405 exit $status
409 pop_stash() {
410 assert_stash_ref "$@"
412 apply_stash "$@" &&
413 drop_stash "$@"
416 drop_stash () {
417 assert_stash_ref "$@"
419 git reflog delete --updateref --rewrite "${REV}" &&
420 say "Dropped ${REV} ($s)" || die "${REV}: Could not drop stash entry"
422 # clear_stash if we just dropped the last stash entry
423 git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
426 apply_to_branch () {
427 test -n "$1" || die 'No branch name specified'
428 branch=$1
429 shift 1
431 set -- --index "$@"
432 assert_stash_like "$@"
434 git checkout -b $branch $REV^ &&
435 apply_stash "$@" && {
436 test -z "$IS_STASH_REF" || drop_stash "$@"
440 PARSE_CACHE='--not-parsed'
441 # The default command is "save" if nothing but options are given
442 seen_non_option=
443 for opt
445 case "$opt" in
446 -*) ;;
447 *) seen_non_option=t; break ;;
448 esac
449 done
451 test -n "$seen_non_option" || set "save" "$@"
453 # Main command set
454 case "$1" in
455 list)
456 shift
457 list_stash "$@"
459 show)
460 shift
461 show_stash "$@"
463 save)
464 shift
465 save_stash "$@"
467 apply)
468 shift
469 apply_stash "$@"
471 clear)
472 shift
473 clear_stash "$@"
475 create)
476 if test $# -gt 0 && test "$1" = create
477 then
478 shift
480 create_stash "$*" && echo "$w_commit"
482 drop)
483 shift
484 drop_stash "$@"
486 pop)
487 shift
488 pop_stash "$@"
490 branch)
491 shift
492 apply_to_branch "$@"
495 case $# in
497 save_stash &&
498 say '(To restore them type "git stash apply")'
501 usage
502 esac
504 esac